Index: sansmodels/src/c_models/fcc.cpp
===================================================================
--- sansmodels/src/c_models/fcc.cpp	(revision 67424cdc019bde2f4cbc089828ff660e6f914c2c)
+++ sansmodels/src/c_models/fcc.cpp	(revision 0ba3b08c35684feff124c0657dad569d13717a18)
@@ -21,26 +21,144 @@
 
 #include <math.h>
-#include "models.hh"
 #include "parameters.hh"
 #include <stdio.h>
 using namespace std;
+#include "fcc.h"
 
 extern "C" {
-	#include "libSphere.h"
-	#include "fcc.h"
+#include "libSphere.h"
+}
+
+// Convenience parameter structure
+typedef struct {
+  double scale;
+  double dnn;
+  double d_factor;
+  double radius;
+  double sldSph;
+  double sldSolv;
+  double background;
+  double theta;
+  double phi;
+  double psi;
+} FCParameters;
+
+/**
+ * Function to evaluate 2D scattering function
+ * @param pars: parameters of the FCCCrystalModel
+ * @param q: q-value
+ * @param q_x: q_x / q
+ * @param q_y: q_y / q
+ * @return: function value
+ */
+static double fc_analytical_2D_scaled(FCParameters *pars, double q, double q_x, double q_y) {
+  double b3_x, b3_y, b3_z, b1_x, b1_y;
+  double q_z;
+  double alpha, cos_val_b3, cos_val_b2, cos_val_b1;
+  double a1_dot_q, a2_dot_q,a3_dot_q;
+  double answer;
+  double Pi = 4.0*atan(1.0);
+  double aa, Da, qDa_2, latticeScale, Zq, Fkq, Fkq_2;
+
+  double dp[5];
+  //convert angle degree to radian
+  double theta = pars->theta * Pi/180.0;
+  double phi = pars->phi * Pi/180.0;
+  double psi = pars->psi * Pi/180.0;
+  dp[0] = 1.0;
+  dp[1] = pars->radius;
+  dp[2] = pars->sldSph;
+  dp[3] = pars->sldSolv;
+  dp[4] = 0.0;
+
+  aa = pars->dnn;
+  Da = pars->d_factor*aa;
+  qDa_2 = pow(q*Da,2.0);
+  //contrast = pars->sldSph - pars->sldSolv;
+
+  latticeScale = 4.0*(4.0/3.0)*Pi*(dp[1]*dp[1]*dp[1])/pow(aa*sqrt(2.0),3.0);
+  // q vector
+  q_z = 0.0; // for SANS; assuming qz is negligible
+  /// Angles here are respect to detector coordinate
+  ///  instead of against q coordinate in PRB 36(46), 3(6), 1754(3854)
+  // b3 axis orientation
+  b3_x = sin(theta) * cos(phi);//negative sign here???
+  b3_y = sin(theta) * sin(phi);
+  b3_z = cos(theta);
+  cos_val_b3 =  b3_x*q_x + b3_y*q_y + b3_z*q_z;
+  alpha = acos(cos_val_b3);
+  // b1 axis orientation
+  b1_x = sin(psi);
+  b1_y = cos(psi);
+  cos_val_b1 = (b1_x*q_x + b1_y*q_y);
+  // b2 axis orientation
+  cos_val_b2 = sin(acos(cos_val_b1));
+  // alpha correction
+  cos_val_b2 *= sin(alpha);
+  cos_val_b1 *= sin(alpha);
+
+  // Compute the angle btw vector q and the a3 axis
+  a3_dot_q = 0.5*aa*q*(cos_val_b2+cos_val_b1);
+
+  // a1 axis
+  a1_dot_q = 0.5*aa*q*(cos_val_b2+cos_val_b3);
+
+  // a2 axis
+  a2_dot_q = 0.5*aa*q*(cos_val_b3+cos_val_b1);
+
+  // The following test should always pass
+  if (fabs(cos_val_b3)>1.0) {
+    printf("fcc_ana_2D: Unexpected error: cos(alpha)>1\n");
+    return 0;
+  }
+  // Get Fkq and Fkq_2
+  Fkq = exp(-0.5*pow(Da/aa,2.0)*(a1_dot_q*a1_dot_q+a2_dot_q*a2_dot_q+a3_dot_q*a3_dot_q));
+  Fkq_2 = Fkq*Fkq;
+  // Call Zq=Z1*Z2*Z3
+  Zq = (1.0-Fkq_2)/(1.0-2.0*Fkq*cos(a1_dot_q)+Fkq_2);
+  Zq = Zq * (1.0-Fkq_2)/(1.0-2.0*Fkq*cos(a2_dot_q)+Fkq_2);
+  Zq = Zq * (1.0-Fkq_2)/(1.0-2.0*Fkq*cos(a3_dot_q)+Fkq_2);
+
+  // Use SphereForm directly from libigor
+  answer = SphereForm(dp,q)*Zq;
+
+  //consider scales
+  answer *= latticeScale * pars->scale;
+
+  // This FIXES a singualrity the kernel in libigor.
+  if ( answer == INFINITY || answer == NAN){
+    answer = 0.0;
+  }
+
+  // add background
+  answer += pars->background;
+
+  return answer;
+}
+
+/**
+ * Function to evaluate 2D scattering function
+ * @param pars: parameters of the FCC_ParaCrystal
+ * @param q: q-value
+ * @return: function value
+ */
+static double fc_analytical_2DXY(FCParameters *pars, double qx, double qy){
+  double q;
+  q = sqrt(qx*qx+qy*qy);
+  return fc_analytical_2D_scaled(pars, q, qx/q, qy/q);
 }
 
 FCCrystalModel :: FCCrystalModel() {
-	scale      = Parameter(1.0);
-	dnn		= Parameter(220.0);
-	d_factor = Parameter(0.06);
-	radius     = Parameter(40.0, true);
-	radius.set_min(0.0);
-	sldSph   = Parameter(3.0e-6);
-	sldSolv   = Parameter(6.3e-6);
-	background = Parameter(0.0);
-	theta  = Parameter(0.0, true);
-	phi    = Parameter(0.0, true);
-	psi    = Parameter(0.0, true);
+  scale      = Parameter(1.0);
+  dnn		= Parameter(220.0);
+  d_factor = Parameter(0.06);
+  radius     = Parameter(40.0, true);
+  radius.set_min(0.0);
+  sldSph   = Parameter(3.0e-6);
+  sldSolv   = Parameter(6.3e-6);
+  background = Parameter(0.0);
+  theta  = Parameter(0.0, true);
+  phi    = Parameter(0.0, true);
+  psi    = Parameter(0.0, true);
 }
 
@@ -52,49 +170,49 @@
  */
 double FCCrystalModel :: operator()(double q) {
-	double dp[7];
-
-	// Fill parameter array for IGOR library
-	// Add the background after averaging
-	dp[0] = scale();
-	dp[1] = dnn();
-	dp[2] = d_factor();
-	dp[3] = radius();
-	dp[4] = sldSph();
-	dp[5] = sldSolv();
-	dp[6] = 0.0;
-
-	// Get the dispersion points for the radius
-	vector<WeightPoint> weights_rad;
-	radius.get_weights(weights_rad);
-
-	// Perform the computation, with all weight points
-	double sum = 0.0;
-	double norm = 0.0;
-	double vol = 0.0;
-	double result;
-
-	// Loop over radius weight points
-	for(size_t i=0; i<weights_rad.size(); i++) {
-		dp[3] = weights_rad[i].value;
-
-		//Un-normalize SphereForm by volume
-		result = FCC_ParaCrystal(dp, q) * pow(weights_rad[i].value,3);
-		// This FIXES a singualrity the kernel in libigor.
-		if ( result == INFINITY || result == NAN){
-			result = 0.0;
-		}
-		sum += weights_rad[i].weight
-			* result;
-		//Find average volume
-		vol += weights_rad[i].weight
-			* pow(weights_rad[i].value,3);
-
-		norm += weights_rad[i].weight;
-	}
-
-	if (vol != 0.0 && norm != 0.0) {
-		//Re-normalize by avg volume
-		sum = sum/(vol/norm);}
-	return sum/norm + background();
+  double dp[7];
+
+  // Fill parameter array for IGOR library
+  // Add the background after averaging
+  dp[0] = scale();
+  dp[1] = dnn();
+  dp[2] = d_factor();
+  dp[3] = radius();
+  dp[4] = sldSph();
+  dp[5] = sldSolv();
+  dp[6] = 0.0;
+
+  // Get the dispersion points for the radius
+  vector<WeightPoint> weights_rad;
+  radius.get_weights(weights_rad);
+
+  // Perform the computation, with all weight points
+  double sum = 0.0;
+  double norm = 0.0;
+  double vol = 0.0;
+  double result;
+
+  // Loop over radius weight points
+  for(size_t i=0; i<weights_rad.size(); i++) {
+    dp[3] = weights_rad[i].value;
+
+    //Un-normalize SphereForm by volume
+    result = FCC_ParaCrystal(dp, q) * pow(weights_rad[i].value,3);
+    // This FIXES a singualrity the kernel in libigor.
+    if ( result == INFINITY || result == NAN){
+      result = 0.0;
+    }
+    sum += weights_rad[i].weight
+        * result;
+    //Find average volume
+    vol += weights_rad[i].weight
+        * pow(weights_rad[i].value,3);
+
+    norm += weights_rad[i].weight;
+  }
+
+  if (vol != 0.0 && norm != 0.0) {
+    //Re-normalize by avg volume
+    sum = sum/(vol/norm);}
+  return sum/norm + background();
 }
 
@@ -106,84 +224,84 @@
  */
 double FCCrystalModel :: operator()(double qx, double qy) {
-	FCParameters dp;
-	dp.scale      = scale();
-	dp.dnn   = dnn();
-	dp.d_factor   = d_factor();
-	dp.radius  = radius();
-	dp.sldSph   = sldSph();
-	dp.sldSolv   = sldSolv();
-	dp.background = 0.0;
-	dp.theta  = theta();
-	dp.phi    = phi();
-	dp.psi    = psi();
-
-	// Get the dispersion points for the radius
-	vector<WeightPoint> weights_rad;
-	radius.get_weights(weights_rad);
-
-	// Get angular averaging for theta
-	vector<WeightPoint> weights_theta;
-	theta.get_weights(weights_theta);
-
-	// Get angular averaging for phi
-	vector<WeightPoint> weights_phi;
-	phi.get_weights(weights_phi);
-
-	// Get angular averaging for psi
-	vector<WeightPoint> weights_psi;
-	psi.get_weights(weights_psi);
-
-	// Perform the computation, with all weight points
-	double sum = 0.0;
-	double norm = 0.0;
-	double norm_vol = 0.0;
-	double vol = 0.0;
-	double pi = 4.0*atan(1.0);
-	// Loop over radius weight points
-	for(size_t i=0; i<weights_rad.size(); i++) {
-		dp.radius = weights_rad[i].value;
-		// Average over theta distribution
-		for(size_t j=0; j< weights_theta.size(); j++) {
-			dp.theta = weights_theta[j].value;
-			// Average over phi distribution
-			for(size_t k=0; k< weights_phi.size(); k++) {
-				dp.phi = weights_phi[k].value;
-				// Average over phi distribution
-				for(size_t l=0; l< weights_psi.size(); l++) {
-					dp.psi = weights_psi[l].value;
-					//Un-normalize SphereForm by volume
-					double _ptvalue = weights_rad[i].weight
-										* weights_theta[j].weight
-										* weights_phi[k].weight
-										* weights_psi[l].weight
-										* fc_analytical_2DXY(&dp, qx, qy);
-										//* pow(weights_rad[i].value,3.0);
-					// Consider when there is infinte or nan.
-					if ( _ptvalue == INFINITY || _ptvalue == NAN){
-						_ptvalue = 0.0;
-					}
-					if (weights_theta.size()>1) {
-						_ptvalue *= fabs(sin(weights_theta[j].value*pi/180.0));
-					}
-					sum += _ptvalue;
-					// This model dose not need the volume of spheres correction!!!
-					norm += weights_rad[i].weight
-							* weights_theta[j].weight
-							* weights_phi[k].weight
-							* weights_psi[l].weight;
-				}
-			}
-		}
-	}
-	// Averaging in theta needs an extra normalization
-	// factor to account for the sin(theta) term in the
-	// integration (see documentation).
-	if (weights_theta.size()>1) norm = norm / asin(1.0);
-
-	if (vol != 0.0 && norm_vol != 0.0) {
-		//Re-normalize by avg volume
-		sum = sum/(vol/norm_vol);}
-
-	return sum/norm + background();
+  FCParameters dp;
+  dp.scale      = scale();
+  dp.dnn   = dnn();
+  dp.d_factor   = d_factor();
+  dp.radius  = radius();
+  dp.sldSph   = sldSph();
+  dp.sldSolv   = sldSolv();
+  dp.background = 0.0;
+  dp.theta  = theta();
+  dp.phi    = phi();
+  dp.psi    = psi();
+
+  // Get the dispersion points for the radius
+  vector<WeightPoint> weights_rad;
+  radius.get_weights(weights_rad);
+
+  // Get angular averaging for theta
+  vector<WeightPoint> weights_theta;
+  theta.get_weights(weights_theta);
+
+  // Get angular averaging for phi
+  vector<WeightPoint> weights_phi;
+  phi.get_weights(weights_phi);
+
+  // Get angular averaging for psi
+  vector<WeightPoint> weights_psi;
+  psi.get_weights(weights_psi);
+
+  // Perform the computation, with all weight points
+  double sum = 0.0;
+  double norm = 0.0;
+  double norm_vol = 0.0;
+  double vol = 0.0;
+  double pi = 4.0*atan(1.0);
+  // Loop over radius weight points
+  for(size_t i=0; i<weights_rad.size(); i++) {
+    dp.radius = weights_rad[i].value;
+    // Average over theta distribution
+    for(size_t j=0; j< weights_theta.size(); j++) {
+      dp.theta = weights_theta[j].value;
+      // Average over phi distribution
+      for(size_t k=0; k< weights_phi.size(); k++) {
+        dp.phi = weights_phi[k].value;
+        // Average over phi distribution
+        for(size_t l=0; l< weights_psi.size(); l++) {
+          dp.psi = weights_psi[l].value;
+          //Un-normalize SphereForm by volume
+          double _ptvalue = weights_rad[i].weight
+              * weights_theta[j].weight
+              * weights_phi[k].weight
+              * weights_psi[l].weight
+              * fc_analytical_2DXY(&dp, qx, qy);
+          //* pow(weights_rad[i].value,3.0);
+          // Consider when there is infinte or nan.
+          if ( _ptvalue == INFINITY || _ptvalue == NAN){
+            _ptvalue = 0.0;
+          }
+          if (weights_theta.size()>1) {
+            _ptvalue *= fabs(sin(weights_theta[j].value*pi/180.0));
+          }
+          sum += _ptvalue;
+          // This model dose not need the volume of spheres correction!!!
+          norm += weights_rad[i].weight
+              * weights_theta[j].weight
+              * weights_phi[k].weight
+              * weights_psi[l].weight;
+        }
+      }
+    }
+  }
+  // Averaging in theta needs an extra normalization
+  // factor to account for the sin(theta) term in the
+  // integration (see documentation).
+  if (weights_theta.size()>1) norm = norm / asin(1.0);
+
+  if (vol != 0.0 && norm_vol != 0.0) {
+    //Re-normalize by avg volume
+    sum = sum/(vol/norm_vol);}
+
+  return sum/norm + background();
 }
 
@@ -196,5 +314,5 @@
  */
 double FCCrystalModel :: evaluate_rphi(double q, double phi) {
-	return (*this).operator()(q);
+  return (*this).operator()(q);
 }
 
@@ -204,5 +322,5 @@
  */
 double FCCrystalModel :: calculate_ER() {
-	//NOT implemented yet!!!
-	return 0.0;
-}
+  //NOT implemented yet!!!
+  return 0.0;
+}
Index: sansmodels/src/c_models/fuzzysphere.cpp
===================================================================
--- sansmodels/src/c_models/fuzzysphere.cpp	(revision 67424cdc019bde2f4cbc089828ff660e6f914c2c)
+++ sansmodels/src/c_models/fuzzysphere.cpp	(revision 0ba3b08c35684feff124c0657dad569d13717a18)
@@ -15,11 +15,47 @@
 
 #include <math.h>
-#include "models.hh"
 #include "parameters.hh"
 #include <stdio.h>
+#include <stdlib.h>
 using namespace std;
+#include "fuzzysphere.h"
 
 extern "C" {
-	#include "fuzzysphere.h"
+#include "libSphere.h"
+}
+
+// scattering from a uniform sphere w/ fuzzy surface
+// Modified from FuzzySpheres in libigor/libSphere.c without polydispersion: JHC
+static double fuzzysphere_kernel(double dp[], double q){
+  double pi,x,xr;
+  double radius,sldSph,sldSolv,scale,bkg,delrho,fuzziness,f2,bes,vol,f;   //my local names
+
+  pi = 4.0*atan(1.0);
+  x= q;
+  scale = dp[0];
+  radius = dp[1];
+  fuzziness = dp[2];
+  sldSph = dp[3];
+  sldSolv = dp[4];
+  bkg = dp[5];
+  delrho=sldSph-sldSolv;
+
+  xr = x*radius;
+  //handle xr==0 separately
+  if(xr == 0.0){
+    bes = 1.0;
+  }else{
+    bes = 3.0*(sin(xr)-xr*cos(xr))/(xr*xr*xr);
+  }
+  vol = 4.0*pi/3.0*radius*radius*radius;
+  f = vol*bes*delrho;   // [=] A
+  f *= exp(-0.5*fuzziness*fuzziness*x*x);
+  // normalize to single particle volume, convert to 1/cm
+  f2 = f * f / vol * 1.0e8;   // [=] 1/cm
+
+  f2 *= scale;
+  f2 += bkg;
+
+    return(f2); //scale, and add in the background
 }
 
Index: sansmodels/src/c_models/models.hh
===================================================================
--- sansmodels/src/c_models/models.hh	(revision 6e10cffb542a4045bc3c41ac60c4abf3ed220bb2)
+++ sansmodels/src/c_models/models.hh	(revision 0ba3b08c35684feff124c0657dad569d13717a18)
@@ -27,223 +27,4 @@
 using namespace std;
 
-
-
-class PearlNecklaceModel{
-public:
-	// Model parameters
-	Parameter scale;
-	Parameter radius;
-	Parameter edge_separation;
-	Parameter thick_string;
-	Parameter num_pearls;
-	Parameter sld_pearl;
-	Parameter sld_string;
-	Parameter sld_solv;
-	Parameter background;
-
-	// Constructor
-	PearlNecklaceModel();
-
-	// Operators to get I(Q)
-	double operator()(double q);
-	double operator()(double qx, double qy);
-	double calculate_ER();
-	double evaluate_rphi(double q, double phi);
-};
-
-class FCCrystalModel{
-public:
-	// Model parameters
-	Parameter scale;
-	Parameter dnn;
-	Parameter d_factor;
-	Parameter radius;
-	Parameter sldSph;
-	Parameter sldSolv;
-	Parameter background;
-	Parameter theta;
-	Parameter phi;
-	Parameter psi;
-
-	// Constructor
-	FCCrystalModel();
-
-	// Operators to get I(Q)
-	double operator()(double q);
-	double operator()(double qx, double qy);
-	double calculate_ER();
-	double evaluate_rphi(double q, double phi);
-};
-
-
-class BCCrystalModel{
-public:
-	// Model parameters
-	Parameter scale;
-	Parameter dnn;
-	Parameter d_factor;
-	Parameter radius;
-	Parameter sldSph;
-	Parameter sldSolv;
-	Parameter background;
-	Parameter theta;
-	Parameter phi;
-	Parameter psi;
-
-	// Constructor
-	BCCrystalModel();
-
-	// Operators to get I(Q)
-	double operator()(double q);
-	double operator()(double qx, double qy);
-	double calculate_ER();
-	double evaluate_rphi(double q, double phi);
-};
-
-
-class FuzzySphereModel{
-public:
-	// Model parameters
-	Parameter radius;
-	Parameter scale;
-	Parameter fuzziness;
-	Parameter sldSph;
-	Parameter sldSolv;
-	Parameter background;
-
-	// Constructor
-	FuzzySphereModel();
-
-	// Operators to get I(Q)
-	double operator()(double q);
-	double operator()(double qx, double qy);
-	double calculate_ER();
-	double evaluate_rphi(double q, double phi);
-};
-
-class HardsphereStructure{
-public:
-	// Model parameters
-	Parameter effect_radius;
-	Parameter volfraction;
-
-	// Constructor
-	HardsphereStructure();
-
-	// Operators to get I(Q)
-	double operator()(double q);
-	double operator()(double qx, double qy);
-	double calculate_ER();
-	double evaluate_rphi(double q, double phi);
-};
-
-class StickyHSStructure{
-public:
-	// Model parameters
-	Parameter effect_radius;
-	Parameter volfraction;
-	Parameter perturb;
-	Parameter stickiness;
-
-	// Constructor
-	StickyHSStructure();
-
-	// Operators to get I(Q)
-	double operator()(double q);
-	double operator()(double qx, double qy);
-	double calculate_ER();
-	double evaluate_rphi(double q, double phi);
-};
-
-class SquareWellStructure{
-public:
-	// Model parameters
-	Parameter effect_radius;
-	Parameter volfraction;
-	Parameter welldepth;
-	Parameter wellwidth;
-
-	// Constructor
-	SquareWellStructure();
-
-	// Operators to get I(Q)
-	double operator()(double q);
-	double operator()(double qx, double qy);
-	double calculate_ER();
-	double evaluate_rphi(double q, double phi);
-};
-
-class HayterMSAStructure{
-public:
-	// Model parameters
-	Parameter effect_radius;
-	Parameter charge;
-	Parameter volfraction;
-	Parameter temperature;
-	Parameter saltconc;
-	Parameter dielectconst;
-
-	// Constructor
-	HayterMSAStructure();
-
-	// Operators to get I(Q)
-	double operator()(double q);
-	double operator()(double qx, double qy);
-	double calculate_ER();
-	double evaluate_rphi(double q, double phi);
-};
-
-class DiamEllipFunc{
-public:
-	// Model parameters
-	Parameter radius_a;
-	Parameter radius_b;
-
-	// Constructor
-	DiamEllipFunc();
-
-	// Operators to get I(Q)
-	double operator()(double q);
-	double operator()(double qx, double qy);
-	double calculate_ER();
-	double evaluate_rphi(double q, double phi);
-};
-
-class DiamCylFunc{
-public:
-	// Model parameters
-	Parameter radius;
-	Parameter length;
-
-	// Constructor
-	DiamCylFunc();
-
-	// Operators to get I(Q)
-	double operator()(double q);
-	double operator()(double qx, double qy);
-	double calculate_ER();
-	double evaluate_rphi(double q, double phi);
-};
-
-
-class SLDCalFunc{
-public:
-	// Model parameters
-	Parameter fun_type;
-	Parameter npts_inter;
-	Parameter shell_num;
-	Parameter nu_inter;
-	Parameter sld_left;
-	Parameter sld_right;
-
-	// Constructor
-	SLDCalFunc();
-
-	// Operators to get SLD
-	double operator()(double q);
-	double operator()(double qx, double qy);
-	double calculate_ER();
-	double evaluate_rphi(double q, double phi);
-};
 
 
Index: sansmodels/src/c_models/pearlnecklace.cpp
===================================================================
--- sansmodels/src/c_models/pearlnecklace.cpp	(revision 67424cdc019bde2f4cbc089828ff660e6f914c2c)
+++ sansmodels/src/c_models/pearlnecklace.cpp	(revision 0ba3b08c35684feff124c0657dad569d13717a18)
@@ -1,27 +1,133 @@
 
 #include <math.h>
-#include "models.hh"
 #include "parameters.hh"
 #include <stdio.h>
 using namespace std;
+#include "pearlnecklace.h"
 
 extern "C" {
-	#include "pearlnecklace.h"
+#include "libmultifunc/libfunc.h"
+}
+
+static double pearl_necklace_kernel(double dp[], double q) {
+  // fit parameters
+  double scale = dp[0];
+  double radius = dp[1];
+  double edge_separation = dp[2];
+  double thick_string = dp[3];
+  double num_pearls = dp[4];
+  double sld_pearl = dp[5];
+  double sld_string = dp[6];
+  double sld_solv = dp[7];
+  double background = dp[8];
+
+  //relative slds
+  double contrast_pearl = sld_pearl - sld_solv;
+  double contrast_string = sld_string - sld_solv;
+
+  // number of string segments
+  double num_strings = num_pearls - 1.0;
+
+  //Pi
+  double pi = 4.0*atan(1.0);
+
+  // each volumes
+  double string_vol = edge_separation * pi * pow((thick_string / 2.0), 2);
+  double pearl_vol = 4.0 /3.0 * pi * pow(radius, 3);
+
+  //total volume
+  double tot_vol;
+  //each masses
+  double m_r= contrast_string * string_vol;
+  double m_s= contrast_pearl * pearl_vol;
+  double psi;
+  double gamma;
+  double beta;
+  //form factors
+  double sss; //pearls
+  double srr; //strings
+  double srs; //cross
+  double A_s;
+  double srr_1;
+  double srr_2;
+  double srr_3;
+  double form_factor;
+
+  tot_vol = num_strings * string_vol;
+  tot_vol += num_pearls * pearl_vol;
+
+  //sine functions of a pearl
+  psi = sin(q*radius);
+  psi -= q * radius * cos(q * radius);
+  psi /= pow((q * radius), 3);
+  psi *= 3.0;
+
+  // Note take only 20 terms in Si series: 10 terms may be enough though.
+  gamma = Si(q* edge_separation);
+  gamma /= (q* edge_separation);
+  beta = Si(q * (edge_separation + radius));
+  beta -= Si(q * radius);
+  beta /= (q* edge_separation);
+
+  // center to center distance between the neighboring pearls
+  A_s = edge_separation + 2.0 * radius;
+
+  // form factor for num_pearls
+  sss = 1.0 - pow(sinc(q*A_s), num_pearls );
+  sss /= pow((1.0-sinc(q*A_s)), 2);
+  sss *= -sinc(q*A_s);
+  sss -= num_pearls/2.0;
+  sss += num_pearls/(1.0-sinc(q*A_s));
+  sss *= 2.0 * pow((m_s*psi), 2);
+
+  // form factor for num_strings (like thin rods)
+  srr_1 = -pow(sinc(q*edge_separation/2.0), 2);
+
+  srr_1 += 2.0 * gamma;
+  srr_1 *= num_strings;
+  srr_2 = 2.0/(1.0-sinc(q*A_s));
+  srr_2 *= num_strings;
+  srr_2 *= pow(beta, 2);
+  srr_3 = 1.0 - pow(sinc(q*A_s), num_strings);
+  srr_3 /= pow((1.0-sinc(q*A_s)), 2);
+  srr_3 *= pow(beta, 2);
+  srr_3 *= -2.0;
+
+  // total srr
+  srr = srr_1 + srr_2 + srr_3;
+  srr *= pow(m_r, 2);
+
+  // form factor for correlations
+  srs = 1.0;
+  srs -= pow(sinc(q*A_s), num_strings);
+  srs /= pow((1.0-sinc(q*A_s)), 2);
+  srs *= -sinc(q*A_s);
+  srs += (num_strings/(1.0-sinc(q*A_s)));
+  srs *= 4.0;
+  srs *= (m_r * m_s * beta * psi);
+
+  form_factor = sss + srr + srs;
+  form_factor /= (tot_vol * 1.0e-8); // norm by volume and A^-1 to cm^-1
+
+  // scale and background
+  form_factor *= scale;
+  form_factor += background;
+  return (form_factor);
 }
 
 PearlNecklaceModel :: PearlNecklaceModel() {
-	scale = Parameter(1.0);
-	radius = Parameter(80.0, true);
-	radius.set_min(0.0);
-	edge_separation = Parameter(350.0, true);
-	edge_separation.set_min(0.0);
-	thick_string = Parameter(2.5, true);
-	thick_string.set_min(0.0);
-	num_pearls = Parameter(3);
-	num_pearls.set_min(0.0);
-	sld_pearl = Parameter(1.0e-06);
-	sld_string = Parameter(1.0e-06);
-	sld_solv = Parameter(6.3e-06);
-    background = Parameter(0.0);
+  scale = Parameter(1.0);
+  radius = Parameter(80.0, true);
+  radius.set_min(0.0);
+  edge_separation = Parameter(350.0, true);
+  edge_separation.set_min(0.0);
+  thick_string = Parameter(2.5, true);
+  thick_string.set_min(0.0);
+  num_pearls = Parameter(3);
+  num_pearls.set_min(0.0);
+  sld_pearl = Parameter(1.0e-06);
+  sld_string = Parameter(1.0e-06);
+  sld_solv = Parameter(6.3e-06);
+  background = Parameter(0.0);
 
 }
@@ -33,55 +139,55 @@
  */
 double PearlNecklaceModel :: operator()(double q) {
-	double dp[9];
-	// Fill parameter array for IGOR library
-	// Add the background after averaging
-	dp[0] = scale();
-	dp[1] = radius();
-	dp[2] = edge_separation();
-	dp[3] = thick_string();
-	dp[4] = num_pearls();
-	dp[5] = sld_pearl();
-	dp[6] = sld_string();
-	dp[7] = sld_solv();
-	dp[8] = 0.0;
-	double pi = 4.0*atan(1.0);
-	// No polydispersion supported in this model.
-	// Get the dispersion points for the radius
-	vector<WeightPoint> weights_radius;
-	radius.get_weights(weights_radius);
-	vector<WeightPoint> weights_edge_separation;
-	edge_separation.get_weights(weights_edge_separation);
-	// Perform the computation, with all weight points
-	double sum = 0.0;
-	double norm = 0.0;
-	double vol = 0.0;
-	double string_vol = 0.0;
-	double pearl_vol = 0.0;
-	double tot_vol = 0.0;
-	// Loop over core weight points
-	for(size_t i=0; i<weights_radius.size(); i++) {
-		dp[1] = weights_radius[i].value;
-		// Loop over thick_inter0 weight points
-		for(size_t j=0; j<weights_edge_separation.size(); j++) {
-			dp[2] = weights_edge_separation[j].value;
-			pearl_vol = 4.0 /3.0 * pi * pow(dp[1], 3);
-			string_vol =dp[2] * pi * pow((dp[3] / 2.0), 2);
-			tot_vol = (dp[4] - 1.0) * string_vol;
-			tot_vol += dp[4] * pearl_vol;
-			//Un-normalize Sphere by volume
-			sum += weights_radius[i].weight * weights_edge_separation[j].weight
-				* pearl_necklace_kernel(dp,q) * tot_vol;
-			//Find average volume
-			vol += weights_radius[i].weight * weights_edge_separation[j].weight
-				* tot_vol;
-			norm += weights_radius[i].weight * weights_edge_separation[j].weight;
-		}
-	}
-
-	if (vol != 0.0 && norm != 0.0) {
-		//Re-normalize by avg volume
-		sum = sum/(vol/norm);}
-
-	return sum/norm + background();
+  double dp[9];
+  // Fill parameter array for IGOR library
+  // Add the background after averaging
+  dp[0] = scale();
+  dp[1] = radius();
+  dp[2] = edge_separation();
+  dp[3] = thick_string();
+  dp[4] = num_pearls();
+  dp[5] = sld_pearl();
+  dp[6] = sld_string();
+  dp[7] = sld_solv();
+  dp[8] = 0.0;
+  double pi = 4.0*atan(1.0);
+  // No polydispersion supported in this model.
+  // Get the dispersion points for the radius
+  vector<WeightPoint> weights_radius;
+  radius.get_weights(weights_radius);
+  vector<WeightPoint> weights_edge_separation;
+  edge_separation.get_weights(weights_edge_separation);
+  // Perform the computation, with all weight points
+  double sum = 0.0;
+  double norm = 0.0;
+  double vol = 0.0;
+  double string_vol = 0.0;
+  double pearl_vol = 0.0;
+  double tot_vol = 0.0;
+  // Loop over core weight points
+  for(size_t i=0; i<weights_radius.size(); i++) {
+    dp[1] = weights_radius[i].value;
+    // Loop over thick_inter0 weight points
+    for(size_t j=0; j<weights_edge_separation.size(); j++) {
+      dp[2] = weights_edge_separation[j].value;
+      pearl_vol = 4.0 /3.0 * pi * pow(dp[1], 3);
+      string_vol =dp[2] * pi * pow((dp[3] / 2.0), 2);
+      tot_vol = (dp[4] - 1.0) * string_vol;
+      tot_vol += dp[4] * pearl_vol;
+      //Un-normalize Sphere by volume
+      sum += weights_radius[i].weight * weights_edge_separation[j].weight
+          * pearl_necklace_kernel(dp,q) * tot_vol;
+      //Find average volume
+      vol += weights_radius[i].weight * weights_edge_separation[j].weight
+          * tot_vol;
+      norm += weights_radius[i].weight * weights_edge_separation[j].weight;
+    }
+  }
+
+  if (vol != 0.0 && norm != 0.0) {
+    //Re-normalize by avg volume
+    sum = sum/(vol/norm);}
+
+  return sum/norm + background();
 }
 
@@ -93,6 +199,6 @@
  */
 double PearlNecklaceModel :: operator()(double qx, double qy) {
-	double q = sqrt(qx*qx + qy*qy);
-	return (*this).operator()(q);
+  double q = sqrt(qx*qx + qy*qy);
+  return (*this).operator()(q);
 }
 
@@ -105,5 +211,5 @@
  */
 double PearlNecklaceModel :: evaluate_rphi(double q, double phi) {
-	return (*this).operator()(q);
+  return (*this).operator()(q);
 }
 
@@ -118,60 +224,60 @@
 // sld of solvent.
 double PearlNecklaceModel :: calculate_ER() {
-	PeralNecklaceParameters dp;
-
-	dp.scale = scale();
-	dp.radius = radius();
-	dp.edge_separation = edge_separation();
-	dp.thick_string = thick_string();
-	dp.num_pearls = num_pearls();
-
-	double rad_out = 0.0;
-	// Perform the computation, with all weight points
-	double sum = 0.0;
-	double norm = 0.0;
-	double pi = 4.0*atan(1.0);
-	// No polydispersion supported in this model.
-	// Get the dispersion points for the radius
-	vector<WeightPoint> weights_radius;
-	radius.get_weights(weights_radius);
-	vector<WeightPoint> weights_edge_separation;
-	edge_separation.get_weights(weights_edge_separation);
-	// Perform the computation, with all weight points
-	double string_vol = 0.0;
-	double pearl_vol = 0.0;
-	double tot_vol = 0.0;
-	// Loop over core weight points
-	for(size_t i=0; i<weights_radius.size(); i++) {
-		dp.radius = weights_radius[i].value;
-		// Loop over thick_inter0 weight points
-		for(size_t j=0; j<weights_edge_separation.size(); j++) {
-			dp.edge_separation = weights_edge_separation[j].value;
-			pearl_vol = 4.0 /3.0 * pi * pow(dp.radius , 3);
-			string_vol =dp.edge_separation * pi * pow((dp.thick_string / 2.0), 2);
-			tot_vol = (dp.num_pearls - 1.0) * string_vol;
-			tot_vol += dp.num_pearls * pearl_vol;
-			//Find  volume
-			// This may be a too much approximation
-			//Todo: decided whether or not we keep this calculation
-			sum += weights_radius[i].weight * weights_edge_separation[j].weight
-				* pow(3.0*tot_vol/4.0/pi,0.333333);
-			norm += weights_radius[i].weight * weights_edge_separation[j].weight;
-		}
-	}
-
-	if (norm != 0){
-		//return the averaged value
-		rad_out =  sum/norm;}
-	else{
-		//return normal value
-		pearl_vol = 4.0 /3.0 * pi * pow(dp.radius , 3);
-		string_vol =dp.edge_separation * pi * pow((dp.thick_string / 2.0), 2);
-		tot_vol = (dp.num_pearls - 1.0) * string_vol;
-		tot_vol += dp.num_pearls * pearl_vol;
-
-		rad_out =  pow((3.0*tot_vol/4.0/pi), 0.33333);
-		}
-
-	return rad_out;
-
-}
+  PeralNecklaceParameters dp;
+
+  dp.scale = scale();
+  dp.radius = radius();
+  dp.edge_separation = edge_separation();
+  dp.thick_string = thick_string();
+  dp.num_pearls = num_pearls();
+
+  double rad_out = 0.0;
+  // Perform the computation, with all weight points
+  double sum = 0.0;
+  double norm = 0.0;
+  double pi = 4.0*atan(1.0);
+  // No polydispersion supported in this model.
+  // Get the dispersion points for the radius
+  vector<WeightPoint> weights_radius;
+  radius.get_weights(weights_radius);
+  vector<WeightPoint> weights_edge_separation;
+  edge_separation.get_weights(weights_edge_separation);
+  // Perform the computation, with all weight points
+  double string_vol = 0.0;
+  double pearl_vol = 0.0;
+  double tot_vol = 0.0;
+  // Loop over core weight points
+  for(size_t i=0; i<weights_radius.size(); i++) {
+    dp.radius = weights_radius[i].value;
+    // Loop over thick_inter0 weight points
+    for(size_t j=0; j<weights_edge_separation.size(); j++) {
+      dp.edge_separation = weights_edge_separation[j].value;
+      pearl_vol = 4.0 /3.0 * pi * pow(dp.radius , 3);
+      string_vol =dp.edge_separation * pi * pow((dp.thick_string / 2.0), 2);
+      tot_vol = (dp.num_pearls - 1.0) * string_vol;
+      tot_vol += dp.num_pearls * pearl_vol;
+      //Find  volume
+      // This may be a too much approximation
+      //Todo: decided whether or not we keep this calculation
+      sum += weights_radius[i].weight * weights_edge_separation[j].weight
+          * pow(3.0*tot_vol/4.0/pi,0.333333);
+      norm += weights_radius[i].weight * weights_edge_separation[j].weight;
+    }
+  }
+
+  if (norm != 0){
+    //return the averaged value
+    rad_out =  sum/norm;}
+  else{
+    //return normal value
+    pearl_vol = 4.0 /3.0 * pi * pow(dp.radius , 3);
+    string_vol =dp.edge_separation * pi * pow((dp.thick_string / 2.0), 2);
+    tot_vol = (dp.num_pearls - 1.0) * string_vol;
+    tot_vol += dp.num_pearls * pearl_vol;
+
+    rad_out =  pow((3.0*tot_vol/4.0/pi), 0.33333);
+  }
+
+  return rad_out;
+
+}
